/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the ApplicationSubscriptionInformation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ApplicationSubscriptionInformation{}

// ApplicationSubscriptionInformation struct for ApplicationSubscriptionInformation
type ApplicationSubscriptionInformation struct {
	Identity         *IdentityInfo                      `json:"identity,omitempty"`
	Status           *UserApplicationSubscriptionStatus `json:"status,omitempty"`
	PendingRequestId NullableString                     `json:"pendingRequestId,omitempty"`
}

// NewApplicationSubscriptionInformation instantiates a new ApplicationSubscriptionInformation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewApplicationSubscriptionInformation() *ApplicationSubscriptionInformation {
	this := ApplicationSubscriptionInformation{}
	return &this
}

// NewApplicationSubscriptionInformationWithDefaults instantiates a new ApplicationSubscriptionInformation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewApplicationSubscriptionInformationWithDefaults() *ApplicationSubscriptionInformation {
	this := ApplicationSubscriptionInformation{}
	return &this
}

// GetIdentity returns the Identity field value if set, zero value otherwise.
func (o *ApplicationSubscriptionInformation) GetIdentity() IdentityInfo {
	if o == nil || IsNil(o.Identity) {
		var ret IdentityInfo
		return ret
	}
	return *o.Identity
}

// GetIdentityOk returns a tuple with the Identity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ApplicationSubscriptionInformation) GetIdentityOk() (*IdentityInfo, bool) {
	if o == nil || IsNil(o.Identity) {
		return nil, false
	}
	return o.Identity, true
}

// HasIdentity returns a boolean if a field has been set.
func (o *ApplicationSubscriptionInformation) HasIdentity() bool {
	if o != nil && !IsNil(o.Identity) {
		return true
	}

	return false
}

// SetIdentity gets a reference to the given IdentityInfo and assigns it to the Identity field.
func (o *ApplicationSubscriptionInformation) SetIdentity(v IdentityInfo) {
	o.Identity = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ApplicationSubscriptionInformation) GetStatus() UserApplicationSubscriptionStatus {
	if o == nil || IsNil(o.Status) {
		var ret UserApplicationSubscriptionStatus
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ApplicationSubscriptionInformation) GetStatusOk() (*UserApplicationSubscriptionStatus, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ApplicationSubscriptionInformation) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given UserApplicationSubscriptionStatus and assigns it to the Status field.
func (o *ApplicationSubscriptionInformation) SetStatus(v UserApplicationSubscriptionStatus) {
	o.Status = &v
}

// GetPendingRequestId returns the PendingRequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ApplicationSubscriptionInformation) GetPendingRequestId() string {
	if o == nil || IsNil(o.PendingRequestId.Get()) {
		var ret string
		return ret
	}
	return *o.PendingRequestId.Get()
}

// GetPendingRequestIdOk returns a tuple with the PendingRequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ApplicationSubscriptionInformation) GetPendingRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.PendingRequestId.Get(), o.PendingRequestId.IsSet()
}

// HasPendingRequestId returns a boolean if a field has been set.
func (o *ApplicationSubscriptionInformation) HasPendingRequestId() bool {
	if o != nil && o.PendingRequestId.IsSet() {
		return true
	}

	return false
}

// SetPendingRequestId gets a reference to the given NullableString and assigns it to the PendingRequestId field.
func (o *ApplicationSubscriptionInformation) SetPendingRequestId(v string) {
	o.PendingRequestId.Set(&v)
}

// SetPendingRequestIdNil sets the value for PendingRequestId to be an explicit nil
func (o *ApplicationSubscriptionInformation) SetPendingRequestIdNil() {
	o.PendingRequestId.Set(nil)
}

// UnsetPendingRequestId ensures that no value is present for PendingRequestId, not even an explicit nil
func (o *ApplicationSubscriptionInformation) UnsetPendingRequestId() {
	o.PendingRequestId.Unset()
}

func (o ApplicationSubscriptionInformation) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ApplicationSubscriptionInformation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Identity) {
		toSerialize["identity"] = o.Identity
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if o.PendingRequestId.IsSet() {
		toSerialize["pendingRequestId"] = o.PendingRequestId.Get()
	}
	return toSerialize, nil
}

type NullableApplicationSubscriptionInformation struct {
	value *ApplicationSubscriptionInformation
	isSet bool
}

func (v NullableApplicationSubscriptionInformation) Get() *ApplicationSubscriptionInformation {
	return v.value
}

func (v *NullableApplicationSubscriptionInformation) Set(val *ApplicationSubscriptionInformation) {
	v.value = val
	v.isSet = true
}

func (v NullableApplicationSubscriptionInformation) IsSet() bool {
	return v.isSet
}

func (v *NullableApplicationSubscriptionInformation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableApplicationSubscriptionInformation(val *ApplicationSubscriptionInformation) *NullableApplicationSubscriptionInformation {
	return &NullableApplicationSubscriptionInformation{value: val, isSet: true}
}

func (v NullableApplicationSubscriptionInformation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableApplicationSubscriptionInformation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
